'use strict';

const {Engine} = require('bpmn-engine');
const bent = require('bent');
const fs = require('fs');
var os = require("os");
//const getJSON = require('get-json');


const _id = 55;//Math.floor(Math.random() * 10000);


const _source0 = `
<?xml version="1.0" encoding="UTF-8"?>
  <definitions xmlns="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <process id="theProcess2" isExecutable="true">
    <startEvent id="theStart" />
    <exclusiveGateway id="decision" default="flow2" />
    <endEvent id="end1" />
    <endEvent id="end2" />
    <sequenceFlow id="flow1" sourceRef="theStart" targetRef="decision" />
    <sequenceFlow id="flow2" sourceRef="decision" targetRef="end1" />
    <sequenceFlow id="flow3" sourceRef="decision" targetRef="end2">
      <conditionExpression>true</conditionExpression>
    </sequenceFlow>
  </process>
</definitions>`;

const _source = `
<?xml version="1.0" encoding="UTF-8"?>
<definitions xmlns="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <process id="theProcess" isExecutable="true">
  <startEvent id="theStart" />

  
  <scriptTask id="scriptTask" scriptFormat="Javascript">
    <script>
      <![CDATA[
      
        const self = this;
        const get0 = self.environment.services.get0;
        const get1 = self.environment.services.get1;
       /* 
        //const set = self.environment.services.set;
        get0('https://example.com/test');
        get1('trylala');
        */
      environment.variables.scriptTaskCompleted = true;
     
     environment.variables.ko=777;
     
     environment.output.k='YES!!!';
     get1('script0='+environment.variables.param0);
     environment.variables.param0=environment.variables.param0*2;
        next();
        
        
      ]]>
    </script>
    </scriptTask>
    
      <scriptTask id="scriptTask1" scriptFormat="Javascript">
    <script>
      <![CDATA[
      
        const self = this;
        const get1 = self.environment.services.get1;
        get1('script2='+environment.variables.param0);
     
        next();
        
        
      ]]>
    </script>
    
  </scriptTask>
  <endEvent id="theEnd" />
  <sequenceFlow id="flow1" sourceRef="theStart" targetRef="scriptTask" />
  <sequenceFlow id="flow2" sourceRef="scriptTask" targetRef="scriptTask1" />
  <sequenceFlow id="flow3" sourceRef="scriptTask1" targetRef="theEnd" />
  </process>
</definitions>`;

const engine = Engine({
  name: 'script task example',
  variables: {
    id:_id,
    ko:'kkk'
  },
  source:_source
});

/*
engine.execute((err, execution) => {
  console.log('Execution completed with id', execution.environment.variables.id);
});
*/

engine.execute({
  variables: {
    scriptTaskCompleted: false,
    param0:10
  },
  services: {
    get: /*bent('json')*/f0,
    get0:f0,    
    get1:f1,    
    set,
  }
}, (err, engineApi) => {

console.log('execute0=',engineApi.name, engineApi.environment.variables);
console.log('execute0=',engineApi.name, engineApi.execution);
     
if (err) throw err;
 
console.log('Output:', engineApi.environment.output);
});

engine.on('start', (execution) => {
  console.log('start:', execution.environment.output);
});


engine.on('end', (execution) => {
  console.log('end Output:', execution.environment.output);
});

function f0(p){
     console.log('f0:',p);
}
function f1(p){
     console.log('f1:',p); 
     fs.appendFile("txt.txt", p+os.EOL, 'utf8', function (err) {
  if (err) return console.log(err);
  //console.log('Hello World > helloworld.txt');

                                                  });
}

function set(activity, name, value) {
  activity.logger.debug('set', name, 'to', value);
  console.log('111');
}



/*
fs.writeFile("txt.txt", "0000", 'utf8', function (err) {
  if (err) return console.log(err);
  //console.log('Hello World > helloworld.txt');
                                                  });
*/




